// simple.frag

#extension GL_EXT_gpu_shader4 : enable

//uniform sampler2D toontex;
uniform int       shadowVolumeModeCartoon;
uniform float       boldnessCartoon;

void main (void)
{
    //vec4 color = texture2D(toontex, gl_TexCoord[0].st);
    //gl_FragColor = color;

    float alpha = gl_FrontLightProduct[0].ambient[3];
    if (alpha > 1.0) alpha = 1.0;
        
    float s = gl_TexCoord[0].st[0];
    float t = gl_TexCoord[0].st[1];

    vec4 ambient = gl_FrontMaterial.ambient * float(shadowVolumeModeCartoon);

    if (t < boldnessCartoon/*0.25*/){
	gl_FragColor[0] = 0.0;
	gl_FragColor[1] = 0.0;
	gl_FragColor[2] = 0.0;
    }
    else{
	if (s < 0.2){
	    gl_FragColor = ambient;
	}
	else if (s < 0.75){
	    gl_FragColor = ambient +
		gl_FrontMaterial.diffuse;
	}
	else{
	    gl_FragColor = ambient + 
		gl_FrontMaterial.diffuse +
		gl_FrontMaterial.specular;
	}
    }
    
    gl_FragColor[3] = alpha;
    //gl_FragColor = gl_Color;
}
