
#ifndef _FILTER_FOG_H_
#define _FILTER_FOG_H_

#include "../FILTER/clsFilterBase.h"
#include "../SCENEOBJ/clsSceneObj.h"

#define _FOG_EXP  0
#define _FOG_EXP2 1
#define _FOG_LINEAR 2

class ArrayAndIndex_cls;
class FilterFog_cls;
class FilterPanelPain_cls;

class FilterFogGUI_cls : public FilterGUI_cls {
 public:
    FilterFogGUI_cls(FilterFog_cls *pCParent, 
		     FilterPanelPain_cls *pCPanelPain);
    FilterFog_cls *mpCParent;
    
    int mIndexType;
    int mIndexDensity;
    int mIndexClip;
    
    void SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow,
		      int index);

    static void FuncHookType(void *pUsrDef, void *pArg);
    void HideAndShow();
};

class FilterFogData_cls : public FilterData_cls {
 public:
    FilterFogData_cls();
    ~FilterFogData_cls();

    void CopyFilterDataFromP
	(FilterData_cls *pCFrom,
	 ParamGroup_cls *pCTranslate  = NULL,
	 ParamGroup_cls *pCRotete     = NULL,
	 ParamGroup_cls *pCScale      = NULL,
	 ParamGroup_cls *pCAdditional = NULL);

    ConfItemUINT_cls   mCFogType;
    ConfItemFLOAT_cls  mCFogStart;
    ConfItemFLOAT_cls  mCFogEnd;

    ParamGroup_cls *mpCParameter;
    // {ȊOɎԕωp[^ꍇI[o[Ch
    void UpdateCurrentObj(double doubleIndex); 
};

class FilterFog_cls : public FilterBase_cls {
 public:
    FilterFog_cls (FilterPanelPain_cls *pCPanelPain,
		   FilterFogData_cls *pCInitData = NULL);
    ~FilterFog_cls();

    FilterFogData_cls *GetPCData();

    void SetGLClearColor(double doubleIndex, float clrBG[3]);
    void SetGLFog(double doubleIndex);
    void GLDraw(double doubleIndex, double scale, bool bHittest, int mode);
    void GLDrawRealFog(double doubleIndex);

    wxString GetStrPovFog(double doubleIndex);
};

#endif
