// "clsStructDrawInfo.cpp"

#ifndef _STRUCT_DRAWINFO_H_
#define _STRUCT_DRAWINFO_H_

#include <wx/wx.h>
#include "../MYGL/clsPositionAndDirection.h"
//#include "../PARAMETER/clsMultiParameters.h"

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

#include <vector>

class StructDrawInfo{
 public:
    StructDrawInfo();
    bool mbForceNewDraw;
    void ForceNewDraw();

    PositionAndDirection_cls mCCameraPos;
    
    /*
    Position_cls mCAncPos;
    int mRemappedIndex, mWidth, mHeight;
    int mDisplayMode;
    bool mABoolList[9];
    bool mABoolPolygon[3];
    bool mABoolMirror[3];
    bool mABoolCopying[3];
    int  mACopyFrom[3];
    int  mACopyTo[3];
    double mABoxMin[3];
    double mABoxMax[3];
    double mABoxRotate[4];
    int   mLightNum;
    
    std::vector < std::vector < double > > mVVClipInfoMin;
    std::vector < std::vector < double > > mVVClipInfoMax;
    std::vector < bool > mVClipInfoActive;
    double mAClipMin[3];
    double mAClipMax[3];
    double mATrans[3];
 
    double mAShadeOffset[3];
    
    void SetBoolList(bool b0, bool b1, bool b2, bool b3, bool b4, 
		     bool b5, bool b6, bool b7, bool b8);
    void SetBoolPolygon(bool bPolygon[3]);
    void SetBoolMirror(bool bMirror[3]);
    void SetBoolCopying(bool bCopying[3]);
    void SetCopyFrom(int copyFrom[3]);
    void SetCopyTo(int copyTo[3]);
    void SetBoxInfo(double boxMin[3], double boxMax[3], double boxRotate[4]);
    void SetLightInfo(int lightNum, float lightPos[][4], float lightColor[][4]);
    void SetClipInfo(double clipMin[3], double clipMax[3]);
    void SetTransInfo(double trans[3]);
    void SetClipInfoNew( std::vector < std::vector < double > > VVClipInfoMin,
			 std::vector < std::vector < double > > VVClipInfoMax,
			 std::vector < bool > VVClipInfoActive);
			 
    void SetShadeInfo(double pShadeOffset[3]);

    void SetFilenames(std::vector < wxString > VwstrFilename);
    std::vector < wxString > mVwstrFilename;
    */
    
    int GetDifference(const StructDrawInfo& CR);
};

bool operator==(const StructDrawInfo& CL, const StructDrawInfo& CR);

#endif
