// -*- c -*-
// "clsSphere.cpp"
// (setq c-basic-offset 4)

#ifndef _SPHERE_H_
#define _SPHERE_H_

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

class Sphere_cls{
public:
    Sphere_cls();

    bool mbInitialized;
    int  mDList[4];
    int  mDListNoTex[4];

    double icosahedronv[12][3];
    int    icosahedronface[20][3];

    double icosahedronn[12][3];
    double dummytex2D[2];
    
    void ChangeCoordinate3Dto2D(double vec3D[3], double vec2D[2]);
    void AdjustVec2DOverBoundary(double vector[2], double vectormem[2]);
    void DrawTriangle(double v1[3], double v2[3], double v3[3], bool bUseTex);
    void DivideTriangle
	(double v1[3], double v2[3], double v3[3], int depth, bool bUseTex);
    int  DListDraw(int GLMode, int depth, bool bUseTex = TRUE);

 public:
    void Draw(int type);
    void DrawNoTex(int type);
    void InitializeIfNot();

    void SequentialDraw(int type);
};

#endif
