// -*- c -*-
// "clsDataSetAndName.cpp"

//#ifdef _USE_HDF5

#ifndef _DATASET_AND_NAME_H_
#define _DATASET_AND_NAME_H_

#include "clsHDF5Common.h"

class DataSetAndName_cls : public HDF5Common_cls {
#ifdef _USE_HDF5
public:
    DataSetAndName_cls(H5::CommonFG &CGroup, H5std_string stdstrName,
		       H5G_obj_t objType);
    ~DataSetAndName_cls();
    
    int  GetDimension();
    void GetDimensionSize(int dim, int *pDimSize);
    long long GetNPoints();

    wxString GetStrDim();
    
    void CopyDataTo(void *pData, H5::PredType type);
    
    H5::DataSet *mpCDataSet;
    H5::DataType *mpCDataType;
    H5::DataSpace *mpCDataSpace;

    H5G_obj_t mObjType;
    H5std_string mstdstrName;
    wxString mstrType;
    wxString mstrDatasetInfo;
    int mDatasetPNum;
#endif
};

#endif

//#endif
