// -*- c -*- 
// (setq c-basic-offset 4)
// "clsGLInfo.cpp"

#ifndef _GLINFO_CLS_H_
#define _GLINFO_CLS_H_

#include <string>
#include <wx/wx.h>

class GLInfo_cls{
 public:
    void Initialize();
    
    wxString GetGLVersionStr();
    wxString GetGLSLVersionStr();
    wxString GetGLMaxElementsVertices();
    wxString GetGLMaxElementsIndices();

    std::string mstrGLVersion;
    std::string mstrGLExtentions;
    std::string mstrGLSLVersion;
    int mMajorVersion;
    int mMinorVersion;
    int mGLSLMajorVersion;
    int mGLSLMinorVersion;

    int mMaxElementsVertices;
    int mMaxElementsIndices;
};

#endif
