// -*- c++ -*- 
// "clsGLTexture.cpp"
// (setq c-basic-offset 4)

#ifndef _GLTEXTURE_H_
#define _GLTEXTURE_H_

#include "clsTextureBase.h"

#include <wx/wx.h>

class GLTexture_cls : public TextureBase_cls {
 public:
    GLTexture_cls();
    //~GLTexture_cls();
    
    int    mWidth;
    int    mHeight;
    wxBitmap*   mpCBitmap;
    wxMemoryDC* mpCMemoryDC;

    wxMemoryDC* BeginDC(int width, int height);
    void EndDC(bool bUseAlpha);
    void SetEmptyImage();
    void ClearImage();
    bool LoadImage(wxString strFile, bool bFlip = FALSE);
    void glTexImage2D_RGBSafe(wxImage &CImg);
    void CopyFromImage(wxImage &CImg);
    void CopyFromDataRGBA(unsigned char *pData, int width, int height);
};

#endif
