// "clsTextureBase.h"
// (setq c-basic-offset 4)

#ifndef _TEXTURE_BASE_H_
#define _TEXTURE_BASE_H_

#define _TEX_FIT_HORIZONTAL 0
#define _TEX_FIT_VERTICAL 1
#define _TEX_FIT_CORNER 2

class TextureBase_cls {
public:
    TextureBase_cls();
    ~TextureBase_cls();

    unsigned int mTextureID;
    void BindTexture();

    static void Push2DMatrix(int width, int height);
    static void Pop2DMatrix();
    
    void DrawOnScreen2DFit(int clientWidth, int clientHeight,
			   int fitType = _TEX_FIT_HORIZONTAL,
			   bool bCustom = false);
    void DrawOnScreen2D(int clientWidth, int clientHeight,
			int clipWidth, int clipHeight,
			int offsetX, int offsetY, bool bCustom = false);
};

#endif
