// -*- c -*- 
// "clsParamDrawBase.h"

#include "clsParamDrawBase.h"

ParamDrawBase_cls::
ParamDrawBase_cls(){
    mViewMinX = 0; mViewMaxX = 1;
}

void ParamDrawBase_cls::
SetXViewRange(float viewMinX, float viewMaxX){
    mViewMinX = viewMinX;
    mViewMaxX = viewMaxX;
}

float ParamDrawBase_cls::
GetMappedX(float x){
    return (x - mViewMinX) / (mViewMaxX - mViewMinX);
}

float ParamDrawBase_cls::
GetMappedXInv(float x){
    return mViewMinX + x * (mViewMaxX - mViewMinX);
}
