
#include "clsThreadInterpolateCommon.h"

#include "../../COMMON/CommonDefinitions.h"

int ThreadInterporateCommon_cls::
SearchIDNear(int index, int ID, int range){
    int ini = index - range;
    if (ini > mPNumNext) return -1;
    if (ini < 0) ini = 0;
    int fin = index + range;
    if (fin > mPNumNext) fin = mPNumNext;
    for (int i = ini; i < fin; i++)
	if (mpIDNext[i] == ID) return i;
    return -1;
}

int ThreadInterporateCommon_cls::
SearchIDFull(int ID){
    for (int i = 0; i < mPNumNext/10; i++)
	if (mpIDNext[i] == ID) return i;
    return -1;
}

int ThreadInterporateCommon_cls::
SearchIDNearBy(int i, int ID, int searchLimit){
    int iNext = -1;
    iNext = SearchIDNear(i, ID, 10);
    if (iNext == -1) iNext = SearchIDNear(i, ID, 100);
    if (searchLimit < 2){
	if (iNext == -1) iNext = SearchIDNear(i, ID, 1000);
	if (iNext == -1) iNext = SearchIDNear(i, ID, 10000);
	if (searchLimit < 1)
	    if (iNext == -1) iNext = SearchIDFull(ID);
    }
    return iNext;
}

int ThreadInterporateCommon_cls::
SearchIDFrom(int *pTgtIndex, int ID){
    int tgtIndex = *pTgtIndex;
    while (TRUE){
	if (tgtIndex >= mPNumNext){
	    *pTgtIndex = tgtIndex;
	    return -1;
	}
	if (mpIDNext[tgtIndex] == ID){
	    *pTgtIndex = tgtIndex + 1;
	    return tgtIndex;
	}
	if (mpIDNext[tgtIndex] > ID){
	    if (tgtIndex > *pTgtIndex)
		*pTgtIndex = (tgtIndex - 1);
	    return -1;
	}
	tgtIndex++;
    }
}
