
#ifndef _POV_PHOTONS_H_
#define _POV_PHOTONS_H_

#include "../../COMMON/clsFilename.h"
#include "../../CONFITEM/clsConfItem.h"

#include "clsPovOptions.h"

#include <wx/filename.h>

#define _POV_PHOTONS_NOUSE 0
#define _POV_PHOTONS_USE 1

class MultiInputPanel_cls;
class PovRayGUI_cls;

class PovPhotons_cls : public PovOptions_cls {
 public:
    PovPhotons_cls();

    static PovPhotons_cls* mspCThis;
    
    void SetToDefault();

    void SetMNumPhotons(wxWindow *pCParentPanel, wxString *pstrWorkingDir);

    int  mIndexType, mIndexCount, mIndexMaxTrace;
    
    void HideAndShow();
    static void HookHideAndShow(void *pUsrDef, void *pEvent);
    
    wxString GetStrPovGlobal();
    wxString GetStrPovIni();
    wxString GetStrPovPhotonSetting
	(double alpha, double reflectMin, double reflectMax,
	 bool bKillTarget = FALSE);

    ConfItemUINT_cls      mCType;
    ConfItemINT_cls       mCCount;
    ConfItemINT_cls       mCMaxTrace;
};

#endif
