// "clsPovThread.h"
// (setq c-basic-offset 4)

#include "clsPovThread.h"
#include "clsPovRay.h"
#include "clsPovRayGUI.h"

#include "../COMMON/clsFilename.h"
#include "../MYAPI/MsgBox.h"

#include "../../clsFrameMain.h"
extern FrameMain_cls* GpCMainFrameCLS; // ɗ͎gȂ

#include "../../wxWidgetEnumMenu.h"

#include <wx/filename.h>
#include <wx/file.h>

#define ENDLWX wxT("\n")

ThreadPovRay_cls::
ThreadPovRay_cls() : wxThread(wxTHREAD_DETACHED) {}

void ThreadPovRay_cls::
SetParameters(PovRayCtrl_cls *pCParent, wxString strCommand,
	      wxString strPostSceneCommand, bool *pbFinished){
    //mbRunning = FALSE;
    mpbFinished = pbFinished;
    
    mpCParent = pCParent;
    mstrCommand = strCommand;
    mstrPostSceneCommand = strPostSceneCommand;
    
    if ( Create() != wxTHREAD_NO_ERROR) 
	MsgBoxExit(NULL, "Error!", "Can't create thread");
}

wxThread::ExitCode ThreadPovRay_cls::
Entry(){
    //mbRunning = TRUE;
    
    //mstrCommand << wxT(" >& log.txt");
#ifdef WIN32
    wxString wxCommand = wxConvFile.cWC2WX(mstrCommand.c_str());
    int retval = _wsystem(mstrCommand.c_str());
#else
    wxString wxCommand = wxConvFile.cWC2WX(mstrCommand.c_str());
    int retval = system(wxCommand.ToAscii());
#endif

    printf("Return Value=%d\n", retval);
    if (retval != 0){
	//GpCMainFrameCLS->mstrErr = wxCommand;
	//wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuItemPovError);
	//wxGetTopLevelParent(mpCParent->mpCGUI)->GetParent()->AddPendingEvent(com);
    }
   
    if (mstrPostSceneCommand != wxT("")){
#ifdef WIN32
	wxString strBatFile, strBatCommand;
	strBatFile << mpCParent->GetWorkingDirWithSep() << wxT("tmp.bat");
	strBatCommand << mstrPostSceneCommand << ENDLWX
		      << wxT("del ") << mpCParent->GetWorkingDirWithSep() 
		      << wxT("tmp.bat") << ENDLWX;
	wxFile CFile(strBatFile, wxFile::write);
	if (CFile.IsOpened() == TRUE) 
	    CFile.Write(strBatCommand, wxConvFile);
	
	wxString strPostCommand;
	strPostCommand << mpCParent->GetWorkingDirWithSep() << wxT("tmp.bat");
	int retvalPost = _wsystem(strPostCommand.c_str());
#else
	wxString wxPostSceneCommand = wxConvFile.cWC2WX(mstrPostSceneCommand.c_str());
	int retvalPost = system(wxPostSceneCommand.ToAscii());
	// DEBGUp
	printf("Commands=%ls\n", wxCommand.c_str());
	printf("PostSceneCommands=%ls\n", wxPostSceneCommand.c_str());
#endif
    }
    
    //mbRunning = FALSE;

    /*
    if (mpCParent->mpCGUI != NULL){
	// PovRay҂̎OosawȁIvZXɓNULLɂȂ\
	wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuItemRefresh);
	wxGetTopLevelParent(mpCParent->mpCGUI)->GetParent()->AddPendingEvent(com);
    }
    */

    *mpbFinished = TRUE;

    wxCommandEvent com(wxEVT_COMMAND_MENU_SELECTED, menuPovUpdateLabel);
    mpCParent->mpCGUI->AddPendingEvent(com);

    return (wxThread::ExitCode)retval;
}
