// -*- c -*-
// "clsTexture.cpp"

#ifndef _SCENE_OBJECT_TEXTURE_H_
#define _SCENE_OBJECT_TEXTURE_H_

#include "../CONFITEM/clsConfItem.h"
#include "../POVRAY/clsPovRay.h"

#define _TEX_NORMAL_MAX 2

class TexPropertyGUI_cls;

class SceneObjTexture_cls : public PovSerialize_cls {
public:
    SceneObjTexture_cls();
    ~SceneObjTexture_cls();
    
    ConfItemUINT_cls mCShaderType;
    ConfItemINT_cls  mCShininess;
    
    ConfItemUINT_cls       mCReflectType;
    ConfItemFLOAT_cls      mCReflectMin, mCReflectMax;
    
    ConfItemFLOAT_cls      mCFadeDistance;
    ConfItemFLOAT_cls      mCIOR;

    ConfItemUINT_cls       mCTransmitType;
    ConfItemFLOAT_cls      mCAlpha;

    ConfItemUINT_cls       mCNormalPattern[_TEX_NORMAL_MAX];
    ConfItemFLOAT_cls      mCNormalDegree[_TEX_NORMAL_MAX];
    ConfItemFLOAT_cls      mCNormalScale[_TEX_NORMAL_MAX];

    //void     GetTransparentInfo(float clr[3][4]);
    void     GetAlphaInfo(float clr[3][4]);
    wxString GetStrPovFinishOptions();
    wxString GetStrPovInteriorOptions();
    wxString GetStrPovNormalBase(int index, float scale[3]);
    wxString GetStrPovNormal(wxString strTab);
    
    TexPropertyGUI_cls* mpCLinkedToMe;
    //SceneObjTexture_cls **mppCLinkedMe;
};

#endif

