// -*- c -*- 
// "clsTimeCtrlGUITics.cpp"

#ifndef _TIME_CTRL_GUI_TICS_H_
#define _TIME_CTRL_GUI_TICS_H_

#include "clsTLPanelBase.h"
#include "../PARAMETER/clsTics.h"

class TimeCtrl_cls;

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class TimeCtrlGUITics_cls : public TLPanelBase_cls, Tics_cls {
 public:
    TimeCtrlGUITics_cls(wxWindow *pCParent, TimeCtrl_cls *pCCtrl,
			wxWindowID id, wxPoint pos, wxSize size);
    ~TimeCtrlGUITics_cls();

    void UpdateDisplay(wxAutoBufferedPaintDC &dc);
    void ForceUpdateDisplay();

    void OnSize(wxSizeEvent& event);
    void OnPaint(wxPaintEvent& event);

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
