
#ifndef _UNDO_COMMAND_FILTERMAKE_H_
#define _UNDO_COMMAND_FILTERMAKE_H_

#include "clsUndoManager.h"
#include <wx/wx.h>

class Main_cls;
class FilterCtrl_cls;
class FilterData_cls;
class ParamGroup_cls;

class CommandFilterMake_cls : public CommandItem_cls {
 public:
    CommandFilterMake_cls(FilterCtrl_cls *pCTarget, int type, int pos,
			  FilterData_cls *pCData);
    ~CommandFilterMake_cls();

    FilterCtrl_cls *mpCTarget;
    int      mType;
    int      mPos;
    FilterData_cls* mpCFilterData;
    ParamGroup_cls *mpCParamGroupTranslate;
    ParamGroup_cls *mpCParamGroupRotation;
    ParamGroup_cls *mpCParamGroupScale;
    
    void Execute(bool bFlag = _COMMAND_REDO);
};

class CommandFilterMove_cls : public CommandItem_cls {
 public:
    CommandFilterMove_cls(FilterCtrl_cls *pCTarget, int pos, int direction);
    //~CommandFilterMove_cls();

    FilterCtrl_cls *mpCTarget;
    int      mPos;
    int      mDirection;

    void Execute(bool bFlag = _COMMAND_REDO);
};

#endif
