// -*- c -*- 
// "clsButtonEX.h"

#include "clsCheckBoxEX.h"

wxCheckBoxEX::
wxCheckBoxEX(wxWindow* parent, wxWindowID id, 
	     const wxString& label,
	     const wxPoint& pos, const wxSize& size,
	     long style, 
	     const wxValidator& validator,
	     const wxString& name) :
    wxCheckBox(parent, id, label, pos, size, style, validator, name)
{
    Connect(GetId(), wxEVT_KEY_DOWN,
	    wxKeyEventHandler(wxCheckBoxEX::OnKeyDown));
    Connect(GetId(), wxEVT_COMMAND_CHECKBOX_CLICKED,
	    wxCommandEventHandler(wxCheckBoxEX::OnCheckBox));
}

void wxCheckBoxEX::
OnCheckBox(wxCommandEvent& event){
    if (GetValidator() != NULL)
	GetValidator()->TransferFromWindow();
    event.Skip();
}

wxWindow* wxCheckBoxEX::
GetPWindow(){
    return this;
}

void wxCheckBoxEX::
OnKeyDown(wxKeyEvent& event){
    ProcessKeyEvent(event);
}
