// -*- c++ -*-
// "clsGrammerBase.h"
// (setq c-basic-offset 4)

#include "clsListCtrlEX.h"

BEGIN_EVENT_TABLE(wxListCtrlEX, wxWindow)
EVT_RIGHT_UP(wxListCtrlEX::OnMouse)
END_EVENT_TABLE()

wxListCtrlEX::
wxListCtrlEX(wxWindow* parent, wxWindowID id, 
	     const wxPoint& pos, const wxSize& size, long style):
wxListCtrl(parent, id, pos, size, style)
{
}

void wxListCtrlEX::
AddListItem(wxInt32 nID, std::vector < wxString > VstrItem){
    wxListItem listItem;
    
    if (nID == -1)
	nID = GetNextItem(-1, wxLIST_NEXT_ALL, wxLIST_STATE_SELECTED);
    
    if (nID == -1)// ǉ
	nID = GetItemCount();
    else
	;//nID++; //Î̎

    listItem.SetId(nID);
    listItem.SetMask(wxLIST_MASK_DATA | wxLIST_MASK_STATE);
    listItem.SetData(0L);

    wxString strNum; strNum << GetItemCount();
    listItem.SetText(VstrItem[0]);
    InsertItem(listItem);

    for (int i = 1; i < VstrItem.size(); i++) SetItem(nID, i, VstrItem[i]);
}

void wxListCtrlEX::
OnMouse(wxMouseEvent& event){
    GetParent()->AddPendingEvent(event);
}
