// -*- c -*- 
// "clsHookCtrl.h"

#include "clsHookCtrl.h"

#include "../COMMON/CommonDefinitions.h"

HookCtrl_cls::
HookCtrl_cls(void **ppToInputPanelBase) :
mVpStructFuncHook(0)
{
    mppToInputPanelBase = ppToInputPanelBase;
}

// bUseVeto TRUE ƁASlideřȎHookȂ

void HookCtrl_cls::
SetFuncHook(void (*pFunc)(void*, void*), int type,
	    int ID, bool bUseVeto, void *pArgOvwt, void *pEventOvwr){
    structFuncPointerVoidVoid structFunc;
    structFunc.mpFunc = pFunc;
    structFunc.mType = type;
    structFunc.mbUseVeto = bUseVeto;
    structFunc.mId = ID;
    structFunc.mpArgOvwt = pArgOvwt;
    structFunc.mpEventOvwt = pEventOvwr;
    mVpStructFuncHook.push_back(structFunc);
}

void HookCtrl_cls::
CheckHook(int hookType, void *pEvent, int id, bool bUseHookChange){
    
    for (unsigned int i = 0; i < mVpStructFuncHook.size(); i++)
	if (mVpStructFuncHook[i].mType == hookType){
	    if (mVpStructFuncHook[i].mId != wxID_ANY && 
		mVpStructFuncHook[i].mId != id)
		continue;
	    if (bUseHookChange == FALSE &&
		mVpStructFuncHook[i].mbUseVeto == TRUE)
		continue;
	    
	    void *pArgToSend = mVpStructFuncHook[i].mpArgOvwt;
	    void *pEventToSend = mVpStructFuncHook[i].mpEventOvwt;
	    if (pArgToSend == NULL) pArgToSend = (*mppToInputPanelBase);
	    if (pEventToSend == NULL) pEventToSend = pEvent;
	    (*mVpStructFuncHook[i].mpFunc)(pArgToSend, pEventToSend);
	}
}
