// -*- c -*- 
// (setq c-basic-offset 4)
// "clsAtoiTextCtrl.h"

#include "clsSliderFloat.h"

SliderFloat_cls::
SliderFloat_cls(wxWindow *parent, wxWindowID id, int initvalue,
		int min, int max, int scale,
		wxPoint pos, wxSize size) 
    : SliderInt_cls(parent, id, initvalue, min, max,
		    pos, size)
{
    mScale = scale;
}

void SliderFloat_cls::
SetValueFloat(float value){
    SetValue(value * mScale);
}

void SliderFloat_cls::
SetRangeSliderWrapperFloat(int min, int max, int scale){
    mMin = min; mMax = max; mScale = scale;
    if (mScale > 10)
	SetPageSize(10);
    SetRangeSliderWrapperInt(min, max);
    SetRange(min, max);
}

float SliderFloat_cls::
GetValue(){
    return (float)wxSliderEX::GetValue() / mScale;
}
