// -*- c++ -*-
// "clsWidgetsCommon.cpp"

#ifndef _WIDGET_COMMON_H
#define _WIDGET_COMMON_H

#include <wx/wx.h>

#define wxCEH wxCommandEventHandler

class WidgetCommon_cls {
public:
    void SendEvent(wxWindow *pC, int type, int ID);
    void SendEventToTop(wxWindow *pC, int type, int ID);
    void SendMenuEventToTop(wxWindow *pC, int ID);
    void SendEventToTopParent(wxWindow *pC, int type, int ID);
    void SendKeyEventToTop(wxWindow *pC, wxKeyEvent& event);
    void SendMenuEvent(wxWindow *pC, int ID);
    void SendButtonEvent(wxWindow *pC, int ID);
    void SendMouseEvent(wxWindow *pC, wxMouseEvent& com);
    void SendMouseEvent(wxWindow *pC, int type, int ID);

    void ConnectButton(wxWindow *pCThis, wxWindow *pC, wxObjectEventFunction func);
};

#endif
