// -*- c -*-
// wxGLCanvas.cpp : AvP[ṼGg |Cg`܂B
// (setq c-basic-offset 4)

//#include "stdafx.h"
#include "Main.h"

#define MAX_LOADSTRING 100

#include <wx/wxprec.h>
#ifdef __BORLANDC__
#pragma hdrstop
#endif

#include "clsMain.h"

#include "wxWidgetEnum.h"
#include "clsFrameMain.h"

#include "SRC/MAINCANVAS/clsGLExtraFrame.h"

IMPLEMENT_APP(MyApp)

#include "SRC/COMMON/CommonDefinitions.h"

bool MyApp::OnInit()
{
    locale.Init(wxLANGUAGE_DEFAULT);
    //locale.Init(wxLANGUAGE_ENGLISH);
    locale.AddCatalogLookupPathPrefix(_T("."));
    locale.AddCatalogLookupPathPrefix(_T("./locale"));
    locale.AddCatalog(_T("Zindaiji2"));

#ifdef WIN32
    setlocale(LC_ALL, "");
#endif
    
    //PNG,JPG,TIFF悤ɂ
    wxImage::AddHandler(new wxBMPHandler());
    wxImage::AddHandler(new wxPNGHandler());
    wxImage::AddHandler(new wxJPEGHandler());
    wxImage::AddHandler(new wxTIFFHandler());
    
    pCMain = new Main_cls;

    pCMain->mpCFrame->mpCGLExtFrame->Show();
    pCMain->mpCFrame->Show(TRUE);
    SetTopWindow(pCMain->mpCFrame);
    
    return true;
}

int MyApp::
OnExit(){
    delete pCMain;
    return 0;
}

MyApp::
~MyApp(){
}
