// -*- c -*-
// "MyVector.cpp"

#ifndef _MYVECTOR_H_
#define _MYVECTOR_H_

namespace MyVector{
    double GetScalarProduct(double vec0[3], double vec1[3]);
    float  GetScalarProduct(float vec0[3], float vec1[3]);
    void GetCrossedVector(double vec0[3], double vec1[3], double vecOut[3]);
    void GetCrossedVector(float  vec0[3], float  vec1[3], float  vecOut[3]);
    double GetNormRelative(double vec0[3], double vec1[3]);
    double GetNorm(double vec[3]);
    double GetNorm(float vec[3]);

    void Normalize(double vec[3], double length);
    void Normalize(float  vec[3], float  length);
    bool Orthogonalize(double vec0[3], double vec1[3]);
    bool Orthogonalize(float  vec0[3], float  vec1[3]);
    void Rotate   (double vec[3], double angle,  int axis);
    // Cӎ̉]
    void RotateAround (double vec[3], double axis[3], double angle);
}

#endif
