// -*- c -*- 
// "clsShaderCtrl.cpp"

#ifndef _SHADER_CTRL_H_
#define _SHADER_CTRL_H_

#include "clsShaderBase.h"
#include "../CONFITEM/clsConfItem.h"

class ShaderCtrl_cls : public ShaderBase_cls {
 public:
    ShaderCtrl_cls();

    ConfItemList_cls mCConfList;
    ConfItemFLOAT_cls mCCartoonBoldness;
    
    GLuint mGL2ProgramGouraud, mGL2ProgramPhong, mGL2ProgramCartoon;
    
    GLint mParamIDLNumGouraud, mParamIDLNumPhong, mParamIDLNumCartoon;
    GLint mParamIDFogModePhong;
    GLint mParamIDShadowModeCartoon;
    GLint mParamIDBoldnessCartoon;

    void InitializeShader(wxWindow *pCParent, bool bShaderAvailable);
    
    void BeginShader(int shaderType, int lightNumber);
    void EndShader(int shaderType);

    void SetShaderParamIDs();
    void SetShaderParamGouraud(int value);
    void SetShaderParamPhong  (int LNum, int fogMode);
    void SetShaderParamCartoon(int value, float boldness);
    void SetShaderParamCartoonShadowMode(bool bShadowMode);
};

#endif
