// -*- c -*-
// "clsDolly.cpp"

#ifndef _DOLLY_H_
#define _DOLLY_H_

//#define _DOLLY_TRANSLATE 0
//#define _DOLLY_SCALE  1
//#define _DOLLY_ROTATE 2

#include "clsMouseCtrl.h"
#include "../MYGL/clsPositionAndDirection.h"

class MouseNormalized_cls;
class Preference_cls;
class SceneObj_cls;

#include <wx/wx.h>

#define _DOLLY_LINKED 7

class Dolly_cls{
public:
    Dolly_cls(Preference_cls *pCPreferenceLink);
    
    Preference_cls *mpCPreferenceLink;

    double mSensitivity;
    double mAspectRatio;
    MouseNormalized_cls *mpCMP;
    float  mMouseX, mMouseY;
    int    mDisplayMode;

    void SetParameter(double sensitivity, MouseNormalized_cls *pCMP, 
		      wxSize sz, int displayMode);
    bool Gyration  (PositionAndDirection_cls *pCCamPos);
    bool Zoom      (PositionAndDirection_cls *pCCamPos, float *pOrthoScale);
    bool MoveCenter(PositionAndDirection_cls *pCCamPos,
		    Position_cls *pCAncPos);
    bool ZoomWheel (PositionAndDirection_cls *pCCamPos, 
		    double wheelRotation, float *pOrthoScale);
};

#endif
