// -*- c -*-
// "clsHitTest.cpp"

#ifndef _HITTEST_H_
#define _HITTEST_H_

#include <vector>

class MainGLCanvas_cls;
class PositionAndDirection_cls;
class FBO_cls;

class HitTest_cls {
 public:
    HitTest_cls();
    ~HitTest_cls();

    unsigned int mBuffer4Selection[100];
    std::vector < std::vector < int > > mVVHittedObjects;

    void Initialize();

    void StartHitTest(float mouseNX, float mouseNY,
		      float aspect, MainGLCanvas_cls *pCGLCanvas,
		      PositionAndDirection_cls *pCCamPos, bool bHittest);

    // K{ł͂ȂAmF\ɕKv
    FBO_cls *mpCFBO;
    
    std::vector < std::vector < int > > GetVVHittedObject();
    void EndHitTest();

    bool mbInitialized;
    bool mbHitTest;
    int  mBufferSize;
    int GetFirstObject();
    int GetFirstObjectSub();
    
    float mPointX, mPointY;
};

#endif
