// -*- c -*-
// "clsGrid.cpp"
// (setq c-basic-offset 4)

#ifndef _GRID_H_
#define _GRID_H_

# define _GRID_INNER 0
# define _GRID_OUTER 1

#include <wx/wx.h>
#include <vector>

#include "../MYGL/clsPositionAndDirection.h"

class TagObject_cls;

class Grid_cls {
 private:
    static bool mbInitialized;
    static int  mDListFlatInner; // gȂׂ̍Obh
    static int  mDListFlatOuter; // gObh

    static int  mFineness;

    static int  DListFlatDraw(int fineness, int GLMode, int gridMode);
    static void InitializeIfNot();
    static bool IsSameTagExist(std::vector < TagObject_cls > *pVCTagObject,
			       wxString strTag);

 public:
    static void DrawCubicGrid
      (double min, double max, int linenum, 
       PositionAndDirection_cls CCamPos, 
       std::vector < TagObject_cls > *pVCTagObject);
    static void DrawBasicGridX
      (double min, double max, int linenum, double offset,
       std::vector < TagObject_cls > *pVCTagObject);
    static void DrawBasicGridY
      (double min, double max, int linenum, double offset,
       std::vector < TagObject_cls > *pVCTagObject);
    static void DrawBasicGridZ
      (double min, double max, int linenum, double offset,
       std::vector < TagObject_cls > *pVCTagObject);
    static void DrawGridFlat(double scale, int nest = 3);
};

#endif
