// (setq c-basic-offset 4)

#include "clsImgSizeTemplate.h"

ImgSizeTemplate_cls::
ImgSizeTemplate_cls(){
    mGeometryTemplate = 0;
    
    mGeomWidth[0] = -1; mGeomHeight[1] = -1;
    mGeomWidth[1] = 1024; mGeomHeight[1] = 768;
    mGeomWidth[2] = 1600; mGeomHeight[2] = 1200;
    mGeomWidth[3] = 800; mGeomHeight[3] = 600;
    mGeomWidth[4] = 640; mGeomHeight[4] = 480;
    mGeomWidth[5] = 320; mGeomHeight[5] = 240;
    mGeomWidth[6] = 1920; mGeomHeight[6] = 1080;
    mGeomWidth[7] = 1366; mGeomHeight[7] = 768;
    mGeomWidth[8] = 960; mGeomHeight[8] = 540;
    mGeomWidth[9] = 480; mGeomHeight[9] = 270;
    mGeomWidth[10] = 1024; mGeomHeight[10] = 1024;
    mGeomWidth[11] = 2048; mGeomHeight[11] = 2048;
    mGeomWidth[12] = 4096; mGeomHeight[12] = 4096;
    mGeomWidth[13] = 512; mGeomHeight[13] = 512;
}

wxString ImgSizeTemplate_cls::
GetStrGeom(int index){
    if (index == 0) return _("Custom");
    wxString str;
    str << mGeomWidth[index] << wxT("x") << mGeomHeight[index];
    return str;
}

bool ImgSizeTemplate_cls::
SetGeometry(int geometry, int *pWidth, int *pHeight){
    if (geometry!= 0){
	*pWidth = mGeomWidth[geometry];
	*pHeight = mGeomHeight[geometry];
	return FALSE;
    }
    return TRUE;
}

void ImgSizeTemplate_cls::
SetIndexFromGeometry(int width, int height){
    mGeometryTemplate = 0;
    for (int i = 0; i < _IMG_SIZE_MAX; i++){
	if (mGeomWidth[i] == width && mGeomHeight[i] == height)
	    mGeometryTemplate = i;
    }
}
