
#include "clsDrawOption.h"
#include "clsDrawOptionGUI.h"

DrawOption_cls::
DrawOption_cls() : mpCGUI(NULL){
    mCConfList.Add(&mCDownSize, wxT("DownSizing="), wxT("1"));
    mCConfList.Add(&mCSortOrder, wxT("SortOrder="), wxT("0"));
    mCConfList.Add(&mCClassify, wxT("Classify="), wxT("1"));
    mCConfList.Add(&mCShadow, wxT("Shadow="), wxT("0"));
}

DrawOption_cls::
~DrawOption_cls(){
    if (mpCGUI != NULL) delete mpCGUI;
}

void DrawOption_cls::
InstantiateGUI(wxWindow *pCParent){
    mpCGUI = new DrawOptionGUI_cls(this, pCParent);
}

void DrawOption_cls::
ReadStrLine(wxString strLine){
    mCConfList.ReadStrLineAll(strLine);
}

wxString DrawOption_cls::
Serialize(){
    return mCConfList.SerializeAll();
}
