// -*- c++ -*- 
// "clsHelpLauncher.h"
// (setq c-basic-offset 4)

#include "clsHelpLauncher.h"

#include "../../clsFrameMain.h"

#include <wx/wx.h>
#include <wx/mimetype.h>

HelpLauncher_cls::
HelpLauncher_cls(FrameMain_cls *pCParent, wxString strPath){
    mpCParentLink = pCParent;
    mstrPath = strPath;   
}

void HelpLauncher_cls::
Execute(){
    wxFileType *ft = wxTheMimeTypesManager->GetFileTypeFromExtension(wxT("chm"));
    wxString cmd;
    bool ok = ft->GetOpenCommand(&cmd, wxFileType::MessageParameters(mstrPath));
    
    mPIDHelp = wxExecute(cmd, wxEXEC_ASYNC, this);
    delete ft;
}

void HelpLauncher_cls::
Terminate(){
    wxKill(mPIDHelp);
}

void HelpLauncher_cls::
OnTerminate(int pid, int status){
    mpCParentLink->mpCHelpLauncher = NULL;
    delete this;
}
