// "clsPovObjectGrid.cpp"
// (c-basic-offset 4)

#ifndef _POV_GRID_H_
#define _POV_GRID_H_

#include <wx/wx.h>

#include "../clsPovSerialize.h"

#include "../../MYGL/clsPositionAndDirection.h"

class PovObjectGrid_cls : public PovSerialize_cls{
 public:
    wxString mstrTab;
    
    void GetStrPovTexture(wxString &strObject, float ambient[4]);

    void GetStrPovBasicGridZ
	(wxString &strObject, double min, double max, int linenum, double offset,
	 double lineWidth);
    void GetStrPovBasicGridX
	(wxString &strObject, double min, double max, int linenum, double offset,
	 double lineWidth);
    void GetStrPovBasicGridY
	(wxString &strObject, double min, double max, int linenum, double offset,
	 double lineWidth);

    void GetStrPovBasicGridCubic
	(wxString &strObject, double min, double max, int linenum, 
	 double lineWidth, PositionAndDirection_cls CCamPos);
    void GetStrPovGridCircular
	(wxString &strObject, double min, double max, int linenum, 
	 double lineWidth, PositionAndDirection_cls CCamPos);
};

#endif
