

#ifndef _POV_FOCAL_BLUR_H_
#define _POV_FOCAL_BLUR_H_

#include "../../COMMON/clsFilename.h"
#include "../../CONFITEM/clsConfItem.h"
#include "../../MYGL/clsPositionAndDirection.h"

#include "clsPovOptions.h"

#include <wx/filename.h>

#define _POV_FOCALBLUR_NOUSE 0
#define _POV_FOCALBLUR_USE 1

#define _POV_FOCUSPOS_ORIGIN 0
#define _POV_FOCUSPOS_ANCHORPOS 1
#define _POV_FOCUSPOS_STEREOFOCUS 2
#define _POV_FOCUSPOS_DISTANCE 3
#define _POV_FOCUSPOS_NUMERIC 4

class MultiInputPanel_cls;
class PovRayGUI_cls;

class PovFocalBlur_cls : public PovOptions_cls {
 public:
    PovFocalBlur_cls();

    static PovFocalBlur_cls* mspCThis;
    
    void SetToDefault();

    void SetMNumFocalBlur(wxWindow *pCParentPanel);

    int mIndexType, mIndexScale, mIndexQuality, mIndexFocusLocationType;
    int mIndexFocusDistance, mIndexFocusLocation;
    
    void HideAndShow();
    static void HookHideAndShow(void *pUsrDef, void *pEvent);
    
    wxString GetPovStrFocalBlur
	(PositionAndDirection_cls mCCameraPos, Position_cls mCAnchorPos,
	 double apatureFactor, double stereoFocus);

    ConfItemUINT_cls  mCType;
    ConfItemFLOAT_cls mCFocalBlurScale;
    ConfItemINT_cls   mCFocalBlurQuality;
    ConfItemUINT_cls  mCFocusLocationType;
    ConfItemFLOAT_cls mCFocusDistance;
    ConfItemFLOATARRAY_cls mCFocusLocation;
};

#endif
