
#include "clsPovOptions.h"

#include "../clsPovRayGUI.h"

#include "../../WIDGETCTRL/clsMultiInputPanel.h"

void PovOptions_cls::
RecalcSize(MultiInputPanel_cls *pCMNum){
    pCMNum->Freeze();
    mspCDialogLink->Freeze();
    mspCDialogLink->RecalcSize();
    mspCDialogLink->ResizeDialog();
    mspCDialogLink->Thaw();
    //mspCDialogLink->Refresh(TRUE);
    pCMNum->Thaw();
}

void PovOptions_cls::
HideAndShowBegin(){
    mpCMNum->Freeze();
}

void PovOptions_cls::
HideAndShowEnd(){
    mpCMNum->Layout();
    mpCMNum->Thaw();
}

void PovOptions_cls::
EnableAll(bool bEnable){
    mpCMNum->EnableItemAll(bEnable);
}

void PovOptions_cls::
ReadStrLine(wxString strLine){
    mCConfList.ReadStrLineAll(strLine);
}

wxString PovOptions_cls::
Serialize(){
    return mCConfList.SerializeAll();
}

PovRayGUI_cls *PovOptions_cls::mspCDialogLink = NULL;
