#ifndef _POV_RENDER_H_
#define _POV_RENDER_H_

#include "../../CONFITEM/clsConfItem.h"
#include "../../WIDGETCTRL/clsMultiInputPanel.h"

#include "clsPovOptions.h"

#define _RENDER_REGION_CUSTOM 2

class PovRayCtrl_cls;
class PovRayGUI_cls;

class PovRender_cls : public PovOptions_cls {
public:
    PovRender_cls(PovRayCtrl_cls *pCCtrlLink);

    static PovRender_cls *mspCThis;
    PovRayCtrl_cls *mpCCtrlLink;

    int mIndexCustomArea;
    int mIndexStereo;
    
    void SetToDefault();
    void SetMNumFormat(wxWindow *pCParentPanel);

    ConfItemUINT_cls    mCRegionType;
    ConfItemINT_cls     mCRegionCustomMin;
    ConfItemINT_cls     mCRegionCustomMax;
    ConfItemINT_cls     mCAnimInit;

    void HideAndShow();
    static void HookHideAndShow(void *pUsrDef, void *pEvent);
    static void HookAutoCalc(void *pUsrDef, void *pEvent);

    void AutoCalc();
};

#endif
