// -*- c -*-
// "clsSceneObj.h"

#include "clsSceneObjTexture.h"
#include "clsTexPropertyGUI.h"

#include "../COMMON/CommonDefinitions.h"

SceneObjTexture_cls::
SceneObjTexture_cls(){
    //ConfItems̏
    //̃NXێĂe邱ƂɂB
    mpCLinkedToMe = NULL;
}

SceneObjTexture_cls::
~SceneObjTexture_cls(){
    if (mpCLinkedToMe != NULL)
	mpCLinkedToMe->ReconnectTexture(NULL);
}

/*
void SceneObjTexture_cls::
GetTransparentInfo(float clr[3][4]){
    if (mCTransmitType.mBody == 0){
	clr[0][3] = 0; clr[1][3] = 0; clr[2][3] = 0;
	return;
    }
    clr[0][3] = 1.0 - mCAlpha.mBody;
    clr[1][3] = 1.0 - mCAlpha.mBody;
    clr[2][3] = 1.0 - mCAlpha.mBody;
}
*/

void SceneObjTexture_cls::
GetAlphaInfo(float clr[3][4]){
    if (mCTransmitType.mBody == 0){
	clr[0][3] = 1; clr[1][3] = 1; clr[2][3] = 1;
	return;
    }
    clr[0][3] = mCAlpha.mBody;
    clr[1][3] = mCAlpha.mBody;
    clr[2][3] = mCAlpha.mBody;
}

wxString SceneObjTexture_cls::
GetStrPovInteriorOptions(){
    wxString strInteriorOptions;
    if (mCIOR.mBody != 1){
	strInteriorOptions << wxT(" ior ") << mCIOR.mBody;
    }
    return strInteriorOptions;
}

wxString SceneObjTexture_cls::
GetStrPovFinishOptions(){
    wxString strFinishOptions;
    if (mCReflectType.mBody > 0){
	strFinishOptions << wxT(" reflection{") 
			 << mCReflectMin.mBody << wxT(",")
			 << mCReflectMax.mBody << wxT("}");
    }
    return strFinishOptions;
}

wxString SceneObjTexture_cls::
GetStrPovNormalBase(int index, float scale[3]){
    
    wxString normalPatternList[12] = {
	wxT("no normal pattern"),
	wxT("agate"), wxT("bozo"),
	wxT("bumps"), wxT("brick"), 
	wxT("cells"), wxT("checker"),
	wxT("crackle"), wxT("dents"),
	wxT("facets"), wxT("marble"), 
	wxT("function { f_ridged_mf(x, y, z, 0.07, 2.2,  7, 0.6, 0.9, 1) }")
    };
    
    wxString strNormal;

    strNormal << normalPatternList[mCNormalPattern[index].mBody];
    strNormal << wxT(" ") << mCNormalDegree[index].mBody;
    strNormal << PovOut3f(wxT(" scale "), scale, 4);
    //strNormal << wxT(" turbulence ") << mCNormalTurb[index].mBody;
    
    return strNormal;
}

wxString SceneObjTexture_cls::
GetStrPovNormal(wxString strTab){
    wxString strNormal;
    if (mCNormalPattern[0].mBody == 0 && mCNormalPattern[1].mBody == 0) return strNormal;
    
    if (mCNormalPattern[0].mBody != 0 && mCNormalPattern[1].mBody != 0){
	float scale0[3] = {1, 1, 1};
	float scale1[3] = {1, 1, 1};

	LOOP_XYZ scale0[xyz] *= mCNormalScale[0].mBody;
	LOOP_XYZ scale1[xyz] *= mCNormalScale[1].mBody;

	/*
	CalcScale(scale0, mCNormalScale[0].mBody, bGlobalCoord, rotAxis);
	CalcScale(scale1, mCNormalScale[1].mBody, bGlobalCoord, rotAxis);
	
	scale0[X] *= scaleFactorX;
	scale0[Y] *= scaleFactorY;
	scale0[Z] *= scaleFactorZ;
	scale1[X] *= scaleFactorX;
	scale1[Y] *= scaleFactorY;
	scale1[Z] *= scaleFactorZ;
	*/
	
	strNormal << L"\tnormal {" << ENDL
		  << L"\t\taverage" << ENDL
		  << L"\t\t\tnormal_map {" << ENDL
		  << L"\t\t\t [ 1.00 " << GetStrPovNormalBase(0, scale0) << L" ]" << ENDL
		  << L"\t\t\t [ 1.00 " << GetStrPovNormalBase(1, scale1) << L" ]" << ENDL
		  << L"\t\t}" << ENDL
		  << L"\t}" << ENDL;
    }
    else{
	for (int i = 0; i < _TEX_NORMAL_MAX; i++)
	    if (mCNormalPattern[i].mBody != 0){
		float scale[3] = {1, 1, 1};
		
		LOOP_XYZ scale[xyz] *= mCNormalScale[i].mBody;

		/*
		CalcScale(scale, mCNormalScale[0].mBody, bGlobalCoord, rotAxis);
		
		scale[X] *= scaleFactorX;
		scale[Y] *= scaleFactorY;
		scale[Z] *= scaleFactorZ;
		*/
		strNormal << L"\tnormal {" << GetStrPovNormalBase(i, scale) <<  L" }" << ENDL;
	    }
    }
    
    return strNormal;
}
