
#include "clsTimeCtrlGUIZoom.h"
#include "clsTimeCtrl.h"

#include "../../clsMain.h"
#include "../WIDGETCTRL/clsBitmapPanel.h"

#include "../COMMON/CommonDefinitions.h"

BEGIN_EVENT_TABLE(TimeCtrlGUIZoom_cls, wxPanel)
END_EVENT_TABLE()

TimeCtrlGUIZoom_cls::
TimeCtrlGUIZoom_cls(wxWindow *pCParent, TimeCtrl_cls *pCCtrl,
		    wxWindowID id, wxPoint pos, wxSize size): 
TLPanelBase_cls(pCParent, pCCtrl, id, pos, size, FALSE)
{
    wxBoxSizer *pCBoxSizerSRC = new wxBoxSizer(wxHORIZONTAL);

    mpCBPanelZoomIn = new BitmapPanel_cls(this, wxID_ANY, wxPoint(_TL_LEFT_WIDTH - 34*1, 0), wxSize(34,12));
    mpCBPanelZoomIn->AddBitmapStr(wxT("wxART_ZOOM_IN"));

    mpCBPanelZoomOut = new BitmapPanel_cls(this, wxID_ANY, wxPoint(_TL_LEFT_WIDTH - 34*2, 0), wxSize(34,12));
    mpCBPanelZoomOut->AddBitmapStr(wxT("wxART_ZOOM_OUT"));
    
    Connect(mpCBPanelZoomIn->GetId(), wxEVT_LEFT_UP,
	    wxMouseEventHandler(TimeCtrlGUIZoom_cls::OnMouseLZoomIn));
    Connect(mpCBPanelZoomOut->GetId(), wxEVT_LEFT_UP,
	    wxMouseEventHandler(TimeCtrlGUIZoom_cls::OnMouseLZoomOut));

    wxPanel *pCSpace = new wxPanel(this, wxID_ANY, wxDefaultPosition, wxSize(_TL_LEFT_WIDTH - 68, 20));
    pCSpace->SetBackgroundColour(wxT("WHITE"));
    
    pCBoxSizerSRC->Add(pCSpace, 0, wxEXPAND);
    pCBoxSizerSRC->Add(mpCBPanelZoomOut, 0, wxEXPAND);
    pCBoxSizerSRC->Add(mpCBPanelZoomIn, 0, wxEXPAND);

    SetSizerAndFit(pCBoxSizerSRC);
}

TimeCtrlGUIZoom_cls::
~TimeCtrlGUIZoom_cls(){
}

void TimeCtrlGUIZoom_cls::
ForceUpdateDisplay(){
}

void TimeCtrlGUIZoom_cls::
OnMouseLZoomIn(wxMouseEvent& event){
    mpCCtrlLink->ExpandAACommand(TRUE);
}

void TimeCtrlGUIZoom_cls::
OnMouseLZoomOut(wxMouseEvent& event){
    mpCCtrlLink->ExpandAACommand(FALSE);
}
