// -*- c -*- 
// "clsColourDialogEX.cpp"

#ifndef _COLOURDIALOG_EX_H_
#define _COLOURDIALOG_EX_H_

#include <wx/wx.h>
#include <wx/colordlg.h>

#include <fstream>
#include <sstream>

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class wxColourDialogEX {
 public:
    wxColourDialogEX(wxWindow* parent, wxColour CColor, 
		     bool bFullChoose = FALSE);
    ~wxColourDialogEX();
    
    wxColour     mCColour;
    wxColourData mCColourData;
    wxColourDialog *mpCDialog;
    
    void SetColourFloat(float *pFloatColor);
    void SetColour(wxColour CColor);
    float mpFloatColor[3];
    int ShowModal();
    unsigned char GetR();
    unsigned char GetG();
    unsigned char GetB();
    float* GetPColorFloat();

    wxString SerializeCustomColors();
    void ReadStrLine(std::wistream &istream, std::wstring strLine);
};

#endif
