// -*- c -*- 
// "clsAtoiTextCtrl.cpp"

#ifndef _ATOI_TEXT_CTRL_H_
#define _ATOI_TEXT_CTRL_H_

#include <wx/wx.h>
#include "EX/clsTextCtrlEX.h"

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class AtoiTextCtrl_cls : 
public TextCtrlEX_cls {
 public:
    AtoiTextCtrl_cls(wxWindow *parent, wxWindowID id, int initvalue,
		     wxPoint pos = wxDefaultPosition, 
		     wxSize size = wxSize(40, -1));

    int  GetValue();
    void UpdateValueFromText(bool assign = FALSE);
    void SetValueInt(int value);
    void SetRange(int min, int max);
    
    int  mMin, mMax;
    int  mPrevValue;
};

#endif
