// -*- c -*- 
// "clsDialogEXKey.cpp"

#ifndef _DIALOG_EX_H_
#define _DIALOG_EX_H_

#include "clsWidgetCommon.h"

class MultiInputPanel_cls;
class MultiInput_cls;

class wxDialogEXKey : public wxDialog, public WidgetCommon_cls {
 public:
    wxDialogEXKey(wxWindow* parent, wxWindowID id, 
		  const wxString& label = wxEmptyString,
		  const wxPoint& pos = wxDefaultPosition,
		  const wxSize& size = wxDefaultSize,
		  wxBitmap bitmap = wxNullBitmap,
		  long style = wxDEFAULT_DIALOG_STYLE, 
		  const wxString& name = wxT("dialogBox"));
    ~wxDialogEXKey();

    wxPoint *mpCPos;
    void SetPCPosInforAtClose(wxPoint *pCPos);
    
    int  mIDCloseButton;
    void SetCloseButtonID(int IDCloseButton);
    wxRect *mpCRectPos;
    void SetScreenRectPos(wxRect *pCRectPos);

    wxBoxSizer *GetPSizerStaticTextVCenter(wxWindow *pCParent, wxString strTag);
    
    bool mbPreventDestroy;
    void CloseEXKey(int retCode = wxID_CANCEL);
    void OnKeyDown(wxKeyEvent& event);

    void OnSize(wxSizeEvent& event);
    void ResizeDialog();
};

#endif
