// -*- c -*- 
// "clsFrameEX.h"

#include "clsFrameEX.h"
#include "clsMultiInputPanel.h"

#include "WX/clsSizeAdjuster.h"

wxFrameEX_cls::
wxFrameEX_cls(wxWindow* parent, wxWindowID id, const wxString& label,
	      const wxPoint& pos, const wxSize& size,
	      wxBitmap CBitmap,
	      long style, const wxString& name) :
wxFrame(parent, id, label, pos, size, style | wxFRAME_FLOAT_ON_PARENT, name)
{
    mbPreventDestroy = TRUE;
    SetBackgroundColour(wxColour(wxT("WHEAT")));
    if (CBitmap.IsOk() == TRUE){
	wxIcon icon; icon.CopyFromBitmap(CBitmap);
	SetIcon(icon);
    }
}

/*
wxBoxSizer *wxFrameEX_cls::
GetPSizerStaticTextVCenter(wxWindow *pCParent, wxString strTag){
    wxBoxSizer *pBoxSizer = new wxBoxSizer(wxVERTICAL);
    wxStaticText *pCStaticText = new wxStaticText(pCParent, wxID_ANY, strTag);
    pBoxSizer->Add( -1, -1, 1, wxEXPAND);
    pBoxSizer->Add( pCStaticText, 0, wxEXPAND);
    pBoxSizer->Add( -1, -1, 1, wxEXPAND);
    return pBoxSizer;
}
*/

void wxFrameEX_cls::
ResizeFrame(){
    GetSizer()->Layout();
    SetSizerAndFit(GetSizer());
    Refresh(FALSE);
    SizeAdjuster_cls::AdjustWindowFitting(this);
}

void wxFrameEX_cls::
OnClose(wxCloseEvent& event){
    if (mbPreventDestroy == TRUE)
	Show(FALSE);
    else
	Destroy();
}
